import java.util.*;
import Jama.*;
public class Logdet extends Submodular{
    public double _getValue(int[] subset){
	int minorsize=0;
	if(subset.length != size){
	    return (double)-1;
	}

	for(int i=0;i<subset.length;i++)
	    if(subset[i] == 1)
		minorsize++;
	if(minorsize == 0)
	    return 0;
	int[] minormat = new int[minorsize];
	for(int i=0,j=0;i<subset.length;i++){
	    if(subset[i] == 1){
		minormat[j] = i;
		j++;
	    }
	}
	Matrix submat = mat.getMatrix(minormat,minormat);
	//System.out.println("determinant "+submat.det());
	return Math.log(submat.det());

    }

    public double getValue(int[] subset){
	return toMonotone(subset);
    }


    Matrix  mat;

    Logdet(int size){
	super(size);
	double rand;
	double[][] array;
	Matrix matA;
	Matrix matB;

	array = new double[size][size];
	for(int i=0;i<size;i++){
	    for(int j=i;j<size;j++){
		rand = Math.random();
		array[i][j] = rand;
		array[j][i] = rand;
	    }
	  
	}
	matA = new Matrix(array);
	matB = matA.transpose();
	mat = matA.times(matB);
    }
    public void print(){
	mat.print(10,10);
    }
    public static void main(String[] args){
	int n=100;
	Logdet ms = new Logdet(n);

	int[] set = new int[n];
	int[] subset = new int[n];
	for(int i=0;i<n;i++){
	    set[i] = (int)Math.round(Math.random());
	    subset[i] = (int) Math.round(Math.random());
	}
	int[] xx = MyUtil.array_intersect(set,subset);
	int[] yy = MyUtil.array_union(set,subset);
	//ms.print();
	int[] testset = new int[n];
	for(int i=0;i<n;i++){
	    testset[i] = 1;
	    System.out.println(ms.getValue(testset));
	}
	System.out.println(ms.getValue(set)+ms.getValue(subset)-ms.getValue(xx)-ms.getValue(yy));

    }
}